<?php
if (!defined('ABSPATH')) exit; // Exit if accessed directly

function formstatus_wpform_support($has_support, $tag)
{
    if ($tag === 'wpforms') {
        return true;
    }

    return $has_support;
}
add_filter('formstatus_support', 'formstatus_wpform_support', 10, 2);

/**
 * Send success status if form submission succeeds.
 */
function formstatus_wpform_success_submission($fields)
{
    formstatus_write_log(['function' => 'formstatus_wpform_success_submission', 'triggered' => true]);

	formstatus_send_submission_status(true);
}
add_action('wpforms_process_complete', 'formstatus_wpform_success_submission', 99999);

/**
 * Send failed status if form submission fails.
 */
function formstatus_wpform_failed_submission($errors)
{
    formstatus_write_log(['function' => 'formstatus_wpform_failed_submission', 'errors' => $errors, 'triggered' => true]);

	if ($errors) {
        formstatus_send_submission_status(false);
    }

    return $errors;
}
add_filter('wpforms_process_initial_errors', 'formstatus_wpform_failed_submission', 99999);
add_filter('wpforms_ajax_submit_errors', 'formstatus_wpform_failed_submission', 99999);

/**
 * Bypass captcha and spam check for form testing.
 */
function formstatus_wpform_bypass_captcha_spamcheck($bypass)
{
    if (empty($_SESSION['formstatus'])) {
        return $bypass;
    }

    formstatus_write_log(['function' => 'formstatus_wpform_bypass_captcha_spamcheck', 'default_return' => $bypass, 'return' => true]);

    return true;
}
add_filter('wpforms_process_bypass_captcha', 'formstatus_wpform_bypass_captcha_spamcheck', 99999);
add_filter('wpforms_process_anti_spam_honeypot_bypass', 'formstatus_wpform_bypass_captcha_spamcheck', 99999);
add_filter('wpforms_process_anti_spam_direct_post_bypass', 'formstatus_wpform_bypass_captcha_spamcheck', 99999);
add_filter('wpforms_frontend_recaptcha_disable', 'formstatus_wpform_bypass_captcha_spamcheck', 99999);

/**
 * Disable saving of entry for form testing.
 */
function formstatus_wpform_disable_saving_entry($save)
{
    if (empty($_SESSION['formstatus'])) {
        return $save;
    }

    formstatus_write_log(['function' => 'formstatus_wpform_disable_saving_entry', 'default_return' => $save, 'return' => false]);

    return false;
}
add_filter('wpforms_entry_save', 'formstatus_wpform_disable_saving_entry', 99999);